// ArduboyShotter.cpp : Defines the entry point for the console application.
//

#include <windows.h>														// We Need The Windows Header
#include <WinUser.h> //contains window manager msg defines

#include "stb_image.h"
#include "psnprintf.h"


int main(int argc, char **argv)
{
   int w = 0;
   int h = 0;
   int n = 0;
   unsigned char* data = 0;
   FILE *output = NULL;// fopen("CastlBoy.sht", "wb");
   FILE *list = fopen("list.txt", "w");
   char listLine[64];
   char fullPath[1024];
   char shortPath[1024]; //fullpath converted to 8.3 format
   char shortName[16];   //8.3 basename extracted
   char pngName[64];     //png file to convert
   char displayName[32]; //the name that will be shown in the menu, longname portion of list.txt
   char shotName[16];    //8.3 1-bit image file output
      
   char search[1024];
   WIN32_FIND_DATA findData;
   HANDLE handle;

   //get module path
   char modulePath[2048];
   GetModuleFileName(NULL, modulePath, sizeof(modulePath));
   char *path = strrchr(modulePath, '\\');
   if(path)
      path[0] = '\0';

   //iterate all hex files
   psnprintf(search, sizeof(search), "%s/*.hex", modulePath);

   handle = FindFirstFile(search, &findData);
   if (handle != INVALID_HANDLE_VALUE)
   {
      do
      {
         //skip directories
         if((findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
            continue;

         printf("File: %s\n", findData.cFileName);


         //get the 8.3 filename of the hex file
         // we have to get the whole path first..
         psnprintf(fullPath, sizeof(fullPath), "%s\\%s", modulePath, findData.cFileName);
         GetShortPathName(fullPath, &shortPath[0], sizeof(shortPath));
         //then extract the filename
         char *pos = strrchr(shortPath, '\\');
         psnprintf(shortName, sizeof(shortName), "%s", &pos[1]);
         //remove extension
         pos = strrchr(shortName, '.');
         if(pos)
            pos[0] = 0;


         //covert longname of hex file into longname of png file
         psnprintf(pngName, sizeof(pngName), "%s", findData.cFileName);
         pos = strrchr(pngName, '.');
         if(pos)
         {
            pos[1] = 'p';
            pos[2] = 'n';
            pos[3] = 'g';
         }
            
         
         //construct output filename for 1-bit shot file
         psnprintf(shotName, sizeof(shotName), "%s.sht", shortName);


         //append game to list file
         psnprintf(displayName, sizeof(displayName), "%s", findData.cFileName);
         pos = strrchr(displayName, '.');
         if(pos)
         {
            pos[0] = 0;
         }
         psnprintf(listLine, sizeof(listLine), "%-8s %-32s", shortName, displayName);
         fputs(listLine, list);
         fputs("\n", list);


         //load screenshot png file
         data = stbi_load(pngName, &w, &h, &n, 4);


         //if screenshot exist, convert it to 1bit format
         if(data)
         {
            //check that screenshot is correct size
            if(w != 64)
            {
               printf("ERROR: %s - Unexpected image width %d\n", pngName, w);
               continue;
            }
            if(h != 64)
            {
               printf("ERROR: %s - Unexpected image height %d\n", pngName, h);
               continue;
            }


            output = fopen(shotName, "wb");

            if(output)
            {
               printf("Generating %s\n", shotName);
            }
            else
            {
               printf("ERROR: Unable to open output file %s\n", shotName);
               fclose(output);
               continue;
            }

            //convert image to our 1-bit line/vertical stripe format
            for(int y = 0; y < 8; y++)
            {
               for(int x = 0; x < 64; x++)
               {
                  char byte = 0;

                  //scan down 
                  for (int i = 0; i < 8; i++)
                  {
                     if(data[(x * 4) + (y * 64 * 4 * 8) + (i * 64 * 4)] > 0x80)
                     {
                        byte |= (1 << i);
                     }
                  }
                  
                  fwrite(&byte, sizeof(char), 1, output);
               }
            }

            fclose(output);
         }
         else
         {
            printf("ERROR: Could not open file %s\n", pngName);
            continue;
         }
         
      } while(FindNextFile(handle, &findData));
   }



   fclose(list);
   

   //DEBUG: Print image in ascii
   /*
   printf("w = %d\n", w);
   printf("h = %d\n", h);
   printf("n = %d\n", n);
   printf("data = %08x\n", data);

   for(int y = 0; y < 64; y++)
   {
      for(int x = 0; x < 54; x++)
      {
         printf("%02x", data[(y * 64 * 4)+(x * 4)]);
      }
      printf("\n");
   }
   */

   
	return 0;
}

